/**
 * 
 */
package commandingAgents;

import commandingAgents.Soldier;
import commandingAgents.Obstacle;
import commandingAgents.RedSoldier;
import commandingAgents.Terrain;
import commandingAgents.PlatoonLeader;
import repast.simphony.context.Context;
import repast.simphony.context.space.continuous.ContinuousSpaceFactory;
import repast.simphony.context.space.continuous.ContinuousSpaceFactoryFinder;
import repast.simphony.context.space.graph.NetworkBuilder;
import repast.simphony.context.space.grid.GridFactory;
import repast.simphony.context.space.grid.GridFactoryFinder;
import repast.simphony.dataLoader.ContextBuilder;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.continuous.NdPoint;
import repast.simphony.space.continuous.RandomCartesianAdder;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridBuilderParameters;
import repast.simphony.space.grid.GridPoint;
import repast.simphony.space.grid.SimpleGridAdder;
import repast.simphony.space.grid.StrictBorders;
import repast.simphony.valueLayer.GridValueLayer;

/**
 * @author Woo-Seop Yun
 *
 */
public class CommandingAgentsBuilder implements ContextBuilder<Object> {
	
	@Override
	public Context build(Context<Object> context) {
		// TODO Auto-generated method stub
		context.setId("commandingAgents");
		
		NetworkBuilder<Object> netBuilder1 = new NetworkBuilder<Object>("blue fire", context, true);
		netBuilder1.buildNetwork();
		
		NetworkBuilder<Object> netBuilder2 = new NetworkBuilder<Object>("red fire", context, true);
		netBuilder2.buildNetwork();
		
		NetworkBuilder<Object> netBuilder3 = new NetworkBuilder<Object>("mortar fire", context, true);
		netBuilder3.buildNetwork();
		
		ContinuousSpaceFactory spaceFactory = ContinuousSpaceFactoryFinder.createContinuousSpaceFactory(null);
		ContinuousSpace<Object> space = spaceFactory.createContinuousSpace("space", context, new RandomCartesianAdder<Object>(), new repast.simphony.space.continuous.StrictBorders(), 40, 60);
		
		GridFactory gridFactory = GridFactoryFinder.createGridFactory(null);
		Grid<Object> grid = gridFactory.createGrid("grid", context, new GridBuilderParameters<Object>(new StrictBorders(), new SimpleGridAdder<Object>(), true, 41, 61));
		
		GridValueLayer terrainLayer = new GridValueLayer("terrain", true, new StrictBorders(), 41, 61);
		context.addValueLayer(terrainLayer);
		
		for(int i=0; i<41; i++){
			for(int j=0; j<61; j++){
				Terrain terrain = new Terrain(i, j);
				context.add(terrain);
				grid.moveTo(terrain, i, j);
				
				if((j==12&&i==0)||(j==13&&i<2)||(j==14&&i<3)||(j==15&&i<5)||(j==16&&i<5)||(j==17&&i<6)||(j==18&&i<7)||(j==19&&i<6)||(j==20&&i<6)||(j==21&&i<6)||(j==22&&i<4)||(j==23&&i<4)
					||(j==23&&i>21&&i<27)||(j==24&&i<5)||(j==24&&i>21&&i<28)||(j==25&&i<5)||(j==25&&i>20&&i<29)||(j==26&&i<5)||(j==26&&i>20&&i<29)||(j==27&&i<5)||(j==27&&i>20&&i<29)
					||(j==28&&i<4)||(j==28&&i>21&&i<28)||(j==29&&i<4)||(j==29&&i>21&&i<28)||(j==30&&i<4)||(j==30&&i>21&&i<27)||(j==31&&i<4)||(j==31&&i>21&&i<26)||(j==32&&i<5)||(j==32&&i>22&&i<26)
					||(j==33&&i<4)||(j==34&&i<3)||(j==35&&i<2)||(j==36&&i<1)||(j==43&&i>23&&i<28)||(j==44&&i>22&&i<29)||(j==45&&i>21&&i<30)||(j==46&&i<1)||(j==46&&i>20&&i<30)||(j==47&&i<1)
					||(j==47&&i>19&&i<31)||(j==48&&i<2)||(j==48&&i>19&&i<32)||(j==49&&i<3)||(j==49&&i>18&&i<32)||(j==50&&i<3)||(j==50&&i>17&&i<33)||(j==51&&i<2)||(j==51&&i>18&&i<32)||(j==52&&i<1)
					||(j==52&&i>19&&i<32)||(j==53&&i>19&&i<31)||(j==54&&i>19&&i<31)||(j==55&&i>20&&i<30)||(j==56&&i>21&&i<29)){
					terrain.changeValue(2);
				}
				else if((j==14&&i>10&&i<16)||(j==14&&i>20&&i<28)||(j==15&&i>9&&i<16)||(j==15&&i>19&&i<29)||(j==16&&i>9&&i<16)||(j==16&&i>17&&i<33)||(j==17&&i>9&&i<16)||(j==17&&i>16&&i<34)
						||(j==18&&i>9)||(j==19&&i>8&&i<22)||(j==19&&i>27)||(j==20&&i>8&&i<20)||(j==20&&i>29)||(j==21&&i>7&&i<19)||(j==21&&i>32)||(j==22&&i>7&&i<18)||(j==22&&i>31)
						||(j==23&&i>6&&i<18)||(j==23&&i>30)||(j==24&&i>6&&i<18)||(j==24&&i>30)||(j==25&&i>6&&i<18)||(j==25&&i>30)||(j==26&&i>6&&i<18)||(j==26&&i>30)||(j==27&&i>6&&i<18)
						||(j==27&&i>30)||(j==28&&i>6&&i<19)||(j==28&&i>30)||(j==29&&i>6&&i<19)||(j==29&&i>30)||(j==30&&i>7&&i<20)||(j==30&&i>30)||(j==31&&i>7&&i<20)||(j==31&&i>30)
						||(j==32&&i>7&&i<20)||(j==32&&i>30)||(j==33&&i>6&&i<20)||(j==33&&i>31)||(j==34&&i>5&&i<19)||(j==34&&i>32)||(j==35&&i>5&&i<18)||(j==35&&i>33)||(j==36&&i>5&&i<20)
						||(j==36&&i>31)||(j==37&&i>5)||(j==38&&i>3)||(j==39&&i>4&&i<21)||(j==39&&i>30)||(j==40&&i>5&&i<16)||(j==40&&i>35)||(j==41&&i>4&&i<14)||(j==41&&i>36)||(j==42&&i>4&&i<12)
						||(j==42&&i>37)||(j==43&&i>5&&i<11)||(j==43&&i>39)||(j==44&&i>5&&i<11)||(j==44&&i>39)||(j==45&&i>6&&i<11)||(j==46&&i>8&&i<11)||(j==50&&i>8&&i<11)||(j==51&&i>6&&i<11)
						||(j==51&&i>39)||(j==52&&i>5&&i<12)||(j==52&&i>38)||(j==53&&i>4&&i<12)||(j==53&&i>37)||(j==54&&i>3&&i<13)||(j==54&&i>37)||(j==55&&i>2&&i<13)||(j==55&&i>37)
						||(j==56&&i>1&&i<14)||(j==56&&i>36)||(j==57&&i>0&&i<15)||(j==57&&i>35)||(j==58&&i<16)||(j==58&&i>34)||(j==59&&i<17)||(j==59&&i>33)||(j==60&&i<18)||(j==60&&i>32)){
					terrain.changeValue(0);
				}
				else{
					terrain.changeValue(1);
				}

				terrainLayer.set(terrain.getMountain(), i, j);
			}
		}
		
		CompanyCommander co = new CompanyCommander(space, grid, "Moving", "Moving", "Moving", "Moving");
		context.add(co);
		space.moveTo(co,  15.0, 47.0);
		NdPoint currentPoint = space.getLocation(co);
		grid.moveTo(co, (int)currentPoint.getX(), (int)currentPoint.getY());
		
		Mortar mortar = new Mortar(space, grid);
		context.add(mortar);
		space.moveTo(mortar, 25.0, 5.0);
		NdPoint mortarPoint = space.getLocation(mortar);
		grid.moveTo(mortar, (int)mortarPoint.getX(), (int)mortarPoint.getY());
		
		int numOfPl = 3;
		for(int i=0 ; i < numOfPl ; i++){
			if(i==0){
				GridPoint RP = new GridPoint(3, 47);
				GridPoint midObjective = new GridPoint(13, 47);
				PlatoonLeader pl = new PlatoonLeader(space, grid, "Assault", RP, midObjective);
				context.add(pl);
				space.moveTo(pl, 3.0, 47.0);
				NdPoint myPoint = space.getLocation(pl);
				grid.moveTo(pl, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i==1){
				GridPoint RP = new GridPoint(5, 48);
				GridPoint midObjective = new GridPoint(15, 47);
				PlatoonLeader pl = new PlatoonLeader(space, grid, "Breach", RP, midObjective);
				context.add(pl);
				space.moveTo(pl, 5.0, 48.0);
				NdPoint myPoint = space.getLocation(pl);
				grid.moveTo(pl, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else{
				GridPoint RP = new GridPoint(25, 28);
				GridPoint midObjective = new GridPoint(25, 39);
				PlatoonLeader pl = new PlatoonLeader(space, grid, "Support", RP, midObjective);
				context.add(pl);
				space.moveTo(pl, 25.0, 28.0);
				NdPoint myPoint = space.getLocation(pl);
				grid.moveTo(pl, (int)myPoint.getX(), (int)myPoint.getY());
			}
		}
		
		int numOfBlue = 90;
		for(int i=0; i < numOfBlue; i++){
				GridPoint objective = null;
			if(i<30){
				objective = new GridPoint(31+2*(i/10), 49-(i%5));
			}
			else if(i<60){
				objective = new GridPoint(22+3*((i-30)/10), 56-((i-30)%5));
			}
			else{
				objective = new GridPoint(16+2*((i-60)/10), 51-((i-60)%5));
			}
			
			Soldier soldier = new Soldier(space, grid, objective, i);
			context.add(soldier);
			
			if(i%2==0){
				space.moveTo(soldier, 2.0+((int)i/3)+4*((int)i/30), 8.0);
			}
			else{
				space.moveTo(soldier, 2.0+((int)i/3)+4*((int)i/30), 7.0);
			}
			
			/*if(i%2==0){
				space.moveTo(soldier, 4.0+4*((int)i/10), 10.0-((int)i%10));
			}
			else{
				space.moveTo(soldier, 4.0+4*((int)i/10)+1, 10.0-((int)i%10));
			}*/
			
			NdPoint myPoint = space.getLocation(soldier);
			grid.moveTo(soldier, (int)myPoint.getX(), (int)myPoint.getY());
		}

		int numOfRed = 48;
		for(int i=0; i< numOfRed; i++){
			RedSoldier redsoldier = new RedSoldier(space, grid);
			context.add(redsoldier);
			if(i<3){
				space.moveTo(redsoldier, 23.0-i, 27.0-i);
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<9){
				space.moveTo(redsoldier, 22.0+(i-3), 24.0);
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<12){
				space.moveTo(redsoldier, 28.0-(i-9), 25.0+(i-9));
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<15){
				space.moveTo(redsoldier, 19.0-(i-12), 46.0-(i-12));
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<21){
				space.moveTo(redsoldier, 18.0+(i-15), 43.0);
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<24){
				space.moveTo(redsoldier, 24.0-(i-21), 44.0+(i-21));
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<27){
				space.moveTo(redsoldier, 29.0-(i-24), 46.0-(i-24));
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<33){
				space.moveTo(redsoldier, 28.0+(i-27), 43.0);
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<36){
				space.moveTo(redsoldier, 34.0-(i-33), 44.0+(i-33));
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<39){
				space.moveTo(redsoldier, 24.0-(i-36), 55.0-(i-36));
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<45){
				space.moveTo(redsoldier, 23.0+(i-39), 52.0);
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else{
				space.moveTo(redsoldier, 29.0-(i-45), 53.0+(i-45));
				NdPoint myPoint = space.getLocation(redsoldier);
				grid.moveTo(redsoldier, (int)myPoint.getX(), (int)myPoint.getY());
			}
		}

		int numOfObstacle = 62;
		for(int i=0; i< numOfObstacle; i++){
			Obstacle obstacle = new Obstacle(space, grid);
			context.add(obstacle);
			if(i<10){
				space.moveTo(obstacle, 22.0-i, 58.0-i);
				NdPoint myPoint = space.getLocation(obstacle);
				grid.moveTo(obstacle, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<16){
				space.moveTo(obstacle, 13, 48.0-(i-10));
				NdPoint myPoint = space.getLocation(obstacle);
				grid.moveTo(obstacle, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<20){
				space.moveTo(obstacle, 14.0+(i-16), 42.0-(i-16));
				NdPoint myPoint = space.getLocation(obstacle);
				grid.moveTo(obstacle, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<37){
				space.moveTo(obstacle, 18.0+(i-20), 39);
				NdPoint myPoint = space.getLocation(obstacle);
				grid.moveTo(obstacle, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<41){
				space.moveTo(obstacle, 35+(i-37), 40+(i-37));
				NdPoint myPoint = space.getLocation(obstacle);
				grid.moveTo(obstacle, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<47){
				space.moveTo(obstacle, 38, 44+(i-41));
				NdPoint myPoint = space.getLocation(obstacle);
				grid.moveTo(obstacle, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else if(i<56){
				space.moveTo(obstacle, 37-(i-47), 50+(i-47));
				NdPoint myPoint = space.getLocation(obstacle);
				grid.moveTo(obstacle, (int)myPoint.getX(), (int)myPoint.getY());
			}
			else{
				space.moveTo(obstacle, 28-(i-56), 58);
				NdPoint myPoint = space.getLocation(obstacle);
				grid.moveTo(obstacle, (int)myPoint.getX(), (int)myPoint.getY());
			}
		}
		
		return context;
	}

}
